package com.fjhx.mail.service.personal.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.mail.entity.personal.dto.PersonalMailboxDto;
import com.fjhx.mail.entity.personal.dto.PersonalMailboxSelectDto;
import com.fjhx.mail.entity.personal.po.PersonalMailbox;
import com.fjhx.mail.entity.personal.vo.PersonalMailboxVo;
import com.fjhx.mail.mapper.personal.PersonalMailboxMapper;
import com.fjhx.mail.service.personal.PersonalMailboxService;
import com.ruoyi.common.constant.StatusConstant;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.ruoyi.common.utils.wrapper.SqlField;
import org.springframework.stereotype.Service;


/**
 * <p>
 * 个人邮箱 服务实现类
 * </p>
 *
 * @author 
 * @since 2023-04-06
 */
@Service
public class PersonalMailboxServiceImpl extends ServiceImpl<PersonalMailboxMapper, PersonalMailbox> implements PersonalMailboxService {

    @Override
    public Page<PersonalMailboxVo> getPage(PersonalMailboxSelectDto dto) {
        IWrapper<PersonalMailbox> wrapper = getWrapper();
        wrapper.eq("pm", PersonalMailbox::getUserId, SecurityUtils.getUserId());
        wrapper.keyword(dto, new SqlField("pm", PersonalMailbox::getMailUser));
        wrapper.orderByDesc("pm", PersonalMailbox::getId);
        Page<PersonalMailboxVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public PersonalMailboxVo detail(Long id) {
        PersonalMailbox PersonalMailbox = this.getById(id);
        PersonalMailboxVo result = BeanUtil.toBean(PersonalMailbox, PersonalMailboxVo.class);
        return result;
    }

    @Override
    public void add(PersonalMailboxDto personalMailboxDto) {
        personalMailboxDto.setStatus(StatusConstant.ENABLE);
        personalMailboxDto.setSyncStatus(1);
        personalMailboxDto.setDefaultStatus(0);
        personalMailboxDto.setUserId(SecurityUtils.getUserId());

        this.save(personalMailboxDto);
    }

    @Override
    public void edit(PersonalMailboxDto personalMailboxDto) {
        this.updateById(personalMailboxDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
